using System;

namespace InfiniTec.SystemUtilities
{
	/// <summary>
	/// Summary description for ByteBag.
	/// </summary>
	internal class ByteBag: IComparable
	{
		long _Size;
		WeakReference _Reference;

		public long Size { get { return _Size; } }

		public byte[] Buffer
		{
			get
			{
				if (!_Reference.IsAlive) throw new ObjectDisposedException("Buffer", "Buffer has already been disposed");

				return (byte[]) _Reference.Target;
			}
		}
		public bool IsAlive { get { return _Reference.IsAlive;}}

		public ByteBag(byte[] buffer)
		{
			_Size = buffer.Length;
			_Reference = new WeakReference(buffer, false);
		}
		#region IComparable Members

		public int CompareTo(object obj)
		{
			ByteBag bag;

			if (obj == null) return 1;
			bag = obj as ByteBag;

			if (bag == null) return 1;

			return _Size.CompareTo(bag._Size);
		}

		#endregion
	}
}
